/*
 * @(#)Inet.java        1.42 98/09/24
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.cldc.io.palm.http;

//import com.sun.kjava.*;
import java.io.IOException;

/**
 *
 */
public
class Inet {
        private static int InetHandle = -1;
        int InetSockH = -1;

        public Inet() {
                if ((InetHandle = initProto()) < 0 && InetHandle > -10) {
                        int lasterr = getlasterror();
                        String msg = "Couldn't init InetLib " + InetHandle + ", " + lasterr;
                        System.out.println(msg);
						throw new RuntimeException("Inet not initialized");
                }

        }


        public void InetShowSignal() {
                showSignal(70, 1);
        }

        public void InetOpenSock(int scheme) throws InetException {
//System.out.println("+1");
                if ((InetSockH = openHTTPsocket(scheme, InetHandle)) == -1)
                        throw new InetException("Couldn't open inet socket");
        }


        public void InetHTTPReqCreateAndSend(String verb, byte[] data, String resource,
            String referer)throws InetException  {

                HTTPCreateAndSendReq(InetSockH, verb, data, resource, referer);
        }

        public int InetSockRead(byte b[], int offset, int count) throws InetException{

                int nread;
//System.out.println("+1");
                nread = readHTTPsocket(InetSockH, b, offset, count);
                return (nread);
        }

        public int InetSockRead(byte b[], int count) {

                int nread;
//System.out.println("+2");
                nread = readHTTPsocket(InetSockH, b, 0, count);
                return (nread);
        }

        public void InetSockClose() throws InetException {
//System.out.println("+4");
                closeHTTPsocket(InetSockH);
        }


    private static native int initProto();
        private native void showSignal(int x, int y);
        private native int openHTTPsocket(int scheme, int handle);
        private native void HTTPCreateAndSendReq(int sockhandle, String verb, byte[] data,
            String resource, String referer) throws InetException;
        private native int readHTTPsocket(int sockhandle, byte b[], int offset,
            int count);
        private native void closeHTTPsocket(int sockhandle) throws InetException;
        public static native int getlasterror();
}
