/*
 *  Copyright (c) 1999 Sun Microsystems, Inc., 901 San Antonio Road,
 *  Palo Alto, CA 94303, U.S.A.  All Rights Reserved.
 *
 *  Sun Microsystems, Inc. has intellectual property rights relating
 *  to the technology embodied in this software.  In particular, and
 *  without limitation, these intellectual property rights may include
 *  one or more U.S. patents, foreign patents, or pending
 *  applications.  Sun, Sun Microsystems, the Sun logo, Java, KJava,
 *  and all Sun-based and Java-based marks are trademarks or
 *  registered trademarks of Sun Microsystems, Inc.  in the United
 *  States and other countries.
 *
 *  This software is distributed under licenses restricting its use,
 *  copying, distribution, and decompilation.  No part of this
 *  software may be reproduced in any form by any means without prior
 *  written authorization of Sun and its licensors, if any.
 *
 *  FEDERAL ACQUISITIONS:  Commercial Software -- Government Users
 *  Subject to Standard License Terms and Conditions
 */

/*
 * WARNING - THIS IS AN EXPERIMENTAL FEATURE OF KVM THAT MAY, OR MAY NOT
 * EXIST IN A FUTURE VERSION OF THIS PRODUCT. IT IS NOT A PART OF THE
 * CLDC SPECIFICATION AND IS PROVIDED FOR ILLUSTRATIVE PURPOSES ONLY
 */

/*
 * NOTE - This code is written a somewhat unusual, and not very object oriented, way.
 * The principal reason for this is that we intend to translate much of this
 * protocol into C and place it in the KVM kernel where is will be much smaller
 * and faster.
 */

package com.sun.cldc.io.palm.storage;
import java.io.*;
import javax.microedition.io.*;
import com.sun.cldc.io.connections.*;
import com.sun.kjava.*;
/**
 * This implements the default "storage:" protocol for Palm
 * <p>
 * This is a REFERENCE IMPLEMENTATION for the Palm. The object of this
 * implementation is correctness not efficiency, and in any case it uses the
 * com.sun.kjava.Database class whose life expediency is not long.
 *
 * @author  Nik Shaylor
 * @version 2.0 3/6/2000
 */


public class OuterProtocol extends ProtocolStub {

    String oselect;

    public Connection prim_openProtocol(String openName, String parms, int mode) throws IOException {
        parse(openName);
        if(type != 0) {
            throw new RuntimeException("Fault in OuterProtocol");
        }
        return this;
    }

    public void prim_closeProtocol() throws IOException {
    }

    /*
     * prim_isDirectory
     */
    public boolean prim_isDirectory() {
        return true;
    }

    /*
     * prim_createDirectoryAndSelect -- TEMP
     */
   public void prim_createDirectoryAndSelect(String name) throws IOException {
        parseString = name;
        ptr = 0;
        int type = token();
        String dbname = name; //TEMP
System.out.println("db.create "+name+" "+creator+" "+type);
        boolean res = Database.create(0, dbname, creator, type, false);
        if(res != true) {
            throw new IOException("Could not create database");
        }
    }

    public void prim_findItemAndSelect(String name) throws IOException {
        parse(name);
    }

    public void prim_clearSelection() throws IOException {
        type = NOTYPE;
    }

    public boolean prim_isSelected() throws IOException {
        Database db = new Database(type, creator, Database.READONLY);
        if(db != null && db.isOpen()) {
System.out.println("Outer isSelected TRUE "+creator+" "+type);
            db.close();
            return true;
        } else {
System.out.println("Outer isSelected FALSE "+creator+" "+type);
            return false;
        }
    }

    public boolean prim_exists() throws IOException {
        return prim_isSelected();
    }


}
